(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    118380,       3215]*)
(*NotebookOutlinePosition[    119012,       3237]*)
(*  CellTagsIndexPosition[    118968,       3233]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[
    \(\(cons := {{1, 0, 0, 0, 0, 0, 0, 0, \[IndentingNewLine]1, 0, 0, 0, 0, 
            0, 0, 0, \[IndentingNewLine]1, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]1, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]1, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]1, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]1, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]1, 0, 0, 0, 0, 0, 0, 
            0}, \[IndentingNewLine]{0, 1, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 1, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 1, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 1, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 1, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 1, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 1, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 1, 0, 0, 0, 0, 0, 
            0}, \[IndentingNewLine]{0, 0, 1, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 1, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 1, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 1, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 1, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 1, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 1, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 1, 0, 0, 0, 0, 
            0}, \[IndentingNewLine]{0, 0, 0, 1, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 1, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 1, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 1, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 1, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 1, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 1, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 1, 0, 0, 0, 
            0}, \[IndentingNewLine]{0, 0, 0, 0, 1, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 1, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 1, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 1, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 1, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 1, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 1, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 1, 0, 0, 
            0}, \[IndentingNewLine]{0, 0, 0, 0, 0, 1, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 1, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 1, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 1, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 1, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 1, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 1, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 1, 0, 
            0}, \[IndentingNewLine]{0, 0, 0, 0, 0, 0, 1, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 1, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 1, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 1, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 1, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 1, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 1, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 1, 
            0}, \[IndentingNewLine]{0, 0, 0, 0, 0, 0, 0, 
            1, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            1, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            1, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            1, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            1, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            1, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            1, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            1}, \[IndentingNewLine]{1, 1, 1, 1, 1, 1, 1, 
            1, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0}, \[IndentingNewLine]{0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]1, 1, 1, 1, 1, 1, 1, 
            1, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0}, \[IndentingNewLine]{0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]1, 1, 1, 1, 1, 1, 1, 
            1, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0}, \[IndentingNewLine]{0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]1, 1, 1, 1, 1, 1, 1, 
            1, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0}, \[IndentingNewLine]{0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]1, 1, 1, 1, 1, 1, 1, 
            1, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0}, \[IndentingNewLine]{0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]1, 1, 1, 1, 1, 1, 1, 
            1, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0}, \[IndentingNewLine]{0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]1, 1, 1, 1, 1, 1, 1, 
            1, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0}, \[IndentingNewLine]{0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]1, 1, 1, 1, 1, 1, 1, 
            1}, \[IndentingNewLine]{1, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]\(-1\), 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]1, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]\(-1\), 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]1, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]\(-1\), 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]1, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]\(-1\), 0, 0, 0, 0, 0, 0, 
            0}, \[IndentingNewLine]{0, 1, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, \(-1\), 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 1, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, \(-1\), 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 1, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, \(-1\), 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 1, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, \(-1\), 0, 0, 0, 0, 0, 
            0}, \[IndentingNewLine]{0, 0, 1, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, \(-1\), 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 1, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, \(-1\), 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 1, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, \(-1\), 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 1, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, \(-1\), 0, 0, 0, 0, 
            0}, \[IndentingNewLine]{0, 0, 0, 1, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, \(-1\), 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 1, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, \(-1\), 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 1, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, \(-1\), 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 1, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, \(-1\), 0, 0, 0, 
            0}, \[IndentingNewLine]{0, 0, 0, 0, 1, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, \(-1\), 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 1, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, \(-1\), 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 1, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, \(-1\), 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 1, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, \(-1\), 0, 0, 
            0}, \[IndentingNewLine]{0, 0, 0, 0, 0, 1, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, \(-1\), 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 1, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, \(-1\), 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 1, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, \(-1\), 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 1, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, \(-1\), 0, 
            0}, \[IndentingNewLine]{0, 0, 0, 0, 0, 0, 1, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, \(-1\), 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 1, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, \(-1\), 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 1, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, \(-1\), 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 1, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, \(-1\), 
            0}, \[IndentingNewLine]{0, 0, 0, 0, 0, 0, 0, 
            1, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 
            0, \(-1\), \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            1, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 
            0, \(-1\), \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            1, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 
            0, \(-1\), \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            1, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 
            0, \(-1\)}, \[IndentingNewLine]{1, \(-1\), 1, \(-1\), 1, \(-1\), 
            1, \(-1\), \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0}, \[IndentingNewLine]{0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]1, \(-1\), 1, \(-1\), 1, \(-1\), 
            1, \(-1\), \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0}, \[IndentingNewLine]{0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]1, \(-1\), 1, \(-1\), 1, \(-1\), 
            1, \(-1\), \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0}, \[IndentingNewLine]{0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]1, \(-1\), 1, \(-1\), 1, \(-1\), 
            1, \(-1\), \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0}, \[IndentingNewLine]{0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]1, \(-1\), 1, \(-1\), 1, \(-1\), 
            1, \(-1\), \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0}, \[IndentingNewLine]{0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]1, \(-1\), 1, \(-1\), 1, \(-1\), 
            1, \(-1\), \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0}, \[IndentingNewLine]{0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]1, \(-1\), 1, \(-1\), 1, \(-1\), 
            1, \(-1\), \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0}, \[IndentingNewLine]{0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]0, 0, 0, 0, 0, 0, 0, 
            0, \[IndentingNewLine]1, \(-1\), 1, \(-1\), 1, \(-1\), 
            1, \(-1\)}};\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(cons // MatrixForm\)], "Input"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", 
              "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "1", "0",
               "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", 
              "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0",
               "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", 
              "0"},
            {"0", "1", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", 
              "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "1",
               "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", 
              "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "1", "0",
               "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", 
              "0"},
            {"0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", 
              "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0",
               "1", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", 
              "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "1",
               "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", 
              "0"},
            {"0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "1", "0", 
              "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0",
               "0", "1", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", 
              "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0",
               "1", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", 
              "0"},
            {"0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "1", 
              "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0",
               "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "1", "0", 
              "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0",
               "0", "1", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", 
              "0"},
            {"0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", 
              "1", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0",
               "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "1", 
              "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0",
               "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "1", "0", 
              "0"},
            {"0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", 
              "0", "1", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0",
               "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", 
              "1", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0",
               "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "1", 
              "0"},
            {"0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", 
              "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0",
               "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", 
              "0", "1", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0",
               "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", 
              "1"},
            {"1", "1", "1", "1", "1", "1", "1", "1", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0"},
            {"0", "0", "0", "0", "0", "0", "0", "0", "1", "1", "1", "1", "1", 
              "1", "1", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0"},
            {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "1", "1", "1", "1", "1", "1", "1", "1", "0", "0",
               "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0"},
            {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "1", "1",
               "1", "1", "1", "1", "1", "1", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0"},
            {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0", "0", "0", "0", "1", "1", "1", "1", "1", "1", 
              "1", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0"},
            {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "1", "1", "1", "1", "1", "1", "1", "1", "0", "0", "0",
               "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0"},
            {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "1", "1", "1",
               "1", "1", "1", "1", "1", "0", "0", "0", "0", "0", "0", "0", 
              "0"},
            {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0", "0", "0", "1", "1", "1", "1", "1", "1", "1", 
              "1"},
            {"1", "0", "0", "0", "0", "0", "0", "0", \(-1\), "0", "0", "0", 
              "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", 
              "0", \(-1\), "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", 
              "0", "0", "0", "0", "0", \(-1\), "0", "0", "0", "0", "0", "0", 
              "0", "1", "0", "0", "0", "0", "0", "0", "0", \(-1\), "0", "0", 
              "0", "0", "0", "0", "0"},
            {"0", "1", "0", "0", "0", "0", "0", "0", "0", \(-1\), "0", "0", 
              "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", 
              "0", \(-1\), "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", 
              "0", "0", "0", "0", "0", \(-1\), "0", "0", "0", "0", "0", "0", 
              "0", "1", "0", "0", "0", "0", "0", "0", "0", \(-1\), "0", "0", 
              "0", "0", "0", "0"},
            {"0", "0", "1", "0", "0", "0", "0", "0", "0", "0", \(-1\), "0", 
              "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0",
               "0", \(-1\), "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", 
              "0", "0", "0", "0", "0", \(-1\), "0", "0", "0", "0", "0", "0", 
              "0", "1", "0", "0", "0", "0", "0", "0", "0", \(-1\), "0", "0", 
              "0", "0", "0"},
            {"0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", \(-1\), 
              "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0",
               "0", "0", \(-1\), "0", "0", "0", "0", "0", "0", "0", "1", "0", 
              "0", "0", "0", "0", "0", "0", \(-1\), "0", "0", "0", "0", "0", 
              "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", \(-1\), "0", 
              "0", "0", "0"},
            {"0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", 
              "0", \(-1\), "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", 
              "0", "0", "0", "0", "0", \(-1\), "0", "0", "0", "0", "0", "0", 
              "0", "1", "0", "0", "0", "0", "0", "0", "0", \(-1\), "0", "0", 
              "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", 
              "0", \(-1\), "0", "0", "0"},
            {"0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", 
              "0", \(-1\), "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", 
              "0", "0", "0", "0", "0", \(-1\), "0", "0", "0", "0", "0", "0", 
              "0", "1", "0", "0", "0", "0", "0", "0", "0", \(-1\), "0", "0", 
              "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", 
              "0", \(-1\), "0", "0"},
            {"0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", 
              "0", \(-1\), "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", 
              "0", "0", "0", "0", "0", \(-1\), "0", "0", "0", "0", "0", "0", 
              "0", "1", "0", "0", "0", "0", "0", "0", "0", \(-1\), "0", "0", 
              "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", 
              "0", \(-1\), "0"},
            {"0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", 
              "0", "0", \(-1\), "0", "0", "0", "0", "0", "0", "0", "1", "0", 
              "0", "0", "0", "0", "0", "0", \(-1\), "0", "0", "0", "0", "0", 
              "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", \(-1\), "0", 
              "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0",
               "0", \(-1\)},
            {"1", \(-1\), "1", \(-1\), "1", \(-1\), "1", \(-1\), "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0"},
            {"0", "0", "0", "0", "0", "0", "0", "0", "1", \(-1\), "1", \(-1\),
               "1", \(-1\), "1", \(-1\), "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0"},
            {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "1", \(-1\), "1", \(-1\), "1", \(-1\), 
              "1", \(-1\), "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0"},
            {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "1", \(-1\), "1", \(-1\), "1", \(-1\), "1", \(-1\), "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0"},
            {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0", "0", "0", "0", "1", \(-1\), "1", \(-1\), 
              "1", \(-1\), "1", \(-1\), "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0", "0"},
            {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "1", \(-1\), "1", \(-1\), "1", \(-1\), "1", \(-1\), 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0"},
            {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "1", \(-1\), 
              "1", \(-1\), "1", \(-1\), "1", \(-1\), "0", "0", "0", "0", "0", 
              "0", "0", "0"},
            {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", "0", "0", "0", "0", "1", \(-1\), "1", \(-1\), "1", \(-1\),
               "1", \(-1\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\((\(Partition[#, 8] &\) /@ RowReduce[cons])\) // MatrixForm\)], "Input"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)},
                    {"0"},
                    {\(-1\)}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"1"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"},
                    {"0"},
                    {"1"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]},
            {
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}], 
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"},
                    {"0"}
                    }], "\[NoBreak]", ")"}]}
            }], "\[NoBreak]", ")"}],
      MatrixForm[ {{{1, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 
        0, -1, 0, -1, 0, -1, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, -1, 0, -1, 
        0, -1, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, -1, 0, -1, 0, -1, 0}, {0, 
        0, 0, 0, 0, 0, 0, 0}}, {{0, 1, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 
        0, 0}, {0, 0, 0, -1, 0, -1, 0, -1}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 
        0, -1, 0, -1, 0, -1}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, -1, 0, -1, 
        0, -1}, {0, 0, 0, 0, 0, 0, 0, 0}}, {{0, 0, 1, 0, 0, 0, 0, 0}, {0, 0, 
        0, 0, 0, 0, 0, 0}, {0, 0, 1, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 
        0}, {0, 0, 1, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 1, 0, 
        0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 1, 0, 0, 0, 0}, {0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 1, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0,
         0}, {0, 0, 0, 1, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 1, 
        0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 1, 0, 0, 0}, {0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 1, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0,
         0}, {0, 0, 0, 0, 1, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
        1, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 1, 0, 0}, {0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 1, 0, 0}, {0, 0, 0, 0, 0, 0, 0,
         0}, {0, 0, 0, 0, 0, 1, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
        0, 1, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0, 1, 0}, {0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 1, 0}, {0, 0, 0, 0, 0, 0, 0,
         0}, {0, 0, 0, 0, 0, 0, 1, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
        0, 0, 1, 0}, {0, 0, 0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0, 0, 1}, {0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 1}, {0, 0, 0, 0, 0, 0, 0,
         0}, {0, 0, 0, 0, 0, 0, 0, 1}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
        0, 0, 0, 1}, {0, 0, 0, 0, 0, 0, 0, 0}}, {{0, 0, 0, 0, 0, 0, 0, 0}, {1,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, -1, 0, -1, 
        0, -1, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, -1, 0, -1, 0, -1, 0}, {0, 
        0, 0, 0, 0, 0, 0, 0}, {0, 0, -1, 0, -1, 0, -1, 0}}, {{0, 0, 0, 0, 0, 
        0, 0, 0}, {0, 1, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 
        0, -1, 0, -1, 0, -1}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, -1, 0, -1, 
        0, -1}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, -1, 0, -1, 0, -1}}, {{0, 
        0, 0, 0, 0, 0, 0, 0}, {0, 0, 1, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 
        0}, {0, 0, 1, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 1, 0, 
        0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 1, 0, 0, 0, 0, 0}}, {{0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 1, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0,
         0}, {0, 0, 0, 1, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 1, 
        0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 1, 0, 0, 0, 0}}, {{0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 1, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0,
         0}, {0, 0, 0, 0, 1, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
        1, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 1, 0, 0, 0}}, {{0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 1, 0, 0}, {0, 0, 0, 0, 0, 0, 0,
         0}, {0, 0, 0, 0, 0, 1, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
        0, 1, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 1, 0, 0}}, {{0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 1, 0}, {0, 0, 0, 0, 0, 0, 0,
         0}, {0, 0, 0, 0, 0, 0, 1, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
        0, 0, 1, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 1, 0}}, {{0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 1}, {0, 0, 0, 0, 0, 0, 0,
         0}, {0, 0, 0, 0, 0, 0, 0, 1}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
        0, 0, 0, 1}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 1}}, {{0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {1, 0, 1, 0, 1, 0, 1,
         0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
        0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}}, {{0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 1, 0, 1, 0, 1, 0,
         1}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
        0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}}, {{0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0,
         0}, {1, 0, 1, 0, 1, 0, 1, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
        0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}}, {{0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0,
         0}, {0, 1, 0, 1, 0, 1, 0, 1}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
        0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}}, {{0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0,
         0}, {0, 0, 0, 0, 0, 0, 0, 0}, {1, 0, 1, 0, 1, 0, 1, 0}, {0, 0, 0, 0, 
        0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}}, {{0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0,
         0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 1, 0, 1, 0, 1, 0, 1}, {0, 0, 0, 0, 
        0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}}, {{0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0,
         0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {1, 0, 1, 0, 
        1, 0, 1, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}}, {{0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0,
         0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 1, 0, 1, 
        0, 1, 0, 1}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}}, {{0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0,
         0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
        0, 0, 0, 0}, {1, 0, 1, 0, 1, 0, 1, 0}, {0, 0, 0, 0, 0, 0, 0, 0}}, {{0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0,
         0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
        0, 0, 0, 0}, {0, 1, 0, 1, 0, 1, 0, 1}, {0, 0, 0, 0, 0, 0, 0, 0}}, {{0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0,
         0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
        0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {1, 0, 1, 0, 1, 0, 1, 0}}, {{0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0,
         0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
        0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 1, 0, 1, 0, 1, 0, 1}}, {{0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0,
         0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
        0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}}, {{0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0,
         0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
        0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}}, {{0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0,
         0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
        0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}}, {{0,
         0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0,
         0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
        0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 
        0}}}]]], "Output"]
}, Open  ]]
},
FrontEndVersion->"5.0 for X",
ScreenRectangle->{{0, 1600}, {0, 1200}},
WindowSize->{520, 600},
WindowMargins->{{214, Automatic}, {Automatic, 153}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 14734, 256, 4107, "Input"],

Cell[CellGroupData[{
Cell[16513, 311, 51, 1, 27, "Input"],
Cell[16567, 314, 13459, 197, 598, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[30063, 516, 93, 1, 27, "Input"],
Cell[30159, 519, 88205, 2693, 4630, "Output"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

